Debian Bug report logs - #544089
does not start without ipv6 kernel support

version graph

Package: tftpd-hpa; Maintainer for tftpd-hpa is Daniel Baumann <mail@daniel-baumann.ch>; Source for tftpd-hpa is src:tftp-hpa.

Reported by: Matthijs Kooijman <matthijs@stdin.nl>

Date: Fri, 28 Aug 2009 17:51:02 UTC

Severity: minor

Tags: ipv6, upstream

Merged with 690535

Found in versions tftp-hpa/5.0-16, tftp-hpa/5.0-5, tftp-hpa/5.0-18

Fixed in version tftp-hpa/5.2-4

Done: Daniel Baumann <daniel.baumann@progress-technologies.net>

Bug is archived. No further changes may be made.

Forwarded to syslinux@zytor.com

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Debian Syslinux Maintainers <syslinux@lists.debian-maintainers.org>:
Bug#544089; Package tftpd-hpa. (Fri, 28 Aug 2009 17:51:10 GMT) Full text and rfc822 format available.

Acknowledgement sent to Matthijs Kooijman <matthijs@stdin.nl>:
New Bug report received and forwarded. Copy sent to Debian Syslinux Maintainers <syslinux@lists.debian-maintainers.org>. (Fri, 28 Aug 2009 17:51:10 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Matthijs Kooijman <matthijs@stdin.nl>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: tftpd-hpa: Does not start when Ipv6 is not available
Date: Fri, 28 Aug 2009 19:41:44 +0200
Package: tftpd-hpa
Version: 5.0-5
Severity: normal

Hi,

I've recently upgraded tftpd-hpa, which stopped working. In my
daemon.log, I see:

	cannot open IPv6 socket, disable IPv6: Address family not supported
	by protocol
	Cannot set nonblock flag on socket: Bad file descriptor

suspecting that these are related, I had a look at the source. It turns
out that the code has support of continuing without ipv6 if the ipv6
fails but ipv4 is opened succesfully, but it even does some stuff with
the ipv6 socket, even when it failed to open, resulting in this error
and the daemon quitting.

In tftpd.c, around line 536, I see:

        if (ai_fam != AF_INET) {
            fd6 = socket(AF_INET6, SOCK_DGRAM, 0);
            if (fd6 < 0) {
                if (fd4 < 0) {
                    syslog(LOG_ERR, "cannot open IPv6 socket: %m");
                    exit(EX_OSERR);
                } else {
                    syslog(LOG_ERR,
                           "cannot open IPv6 socket, disable IPv6: %m");
                }
            }
#ifndef __CYGWIN__
            set_socket_nonblock(fd6, 1);
#endif
            memset(&bindaddr6, 0, sizeof bindaddr6);
            bindaddr6.sin6_family = AF_INET6;
            bindaddr6.sin6_port = htons(IPPORT_TFTP);
        }

It would make sense to move the last four lines into an else of the second if
(fd6 < 0). Perhaps other changes are required as well, I did not test this.

The reason that the ipv6 socket fails to open is that I'm running a custom
kernel with ipv6 disabled, I expect this issue will not bite users that
run a stock Debian kernel, so I'm not giving this bug increased
severity.

Gr.

Matthijs

-- System Information:
Debian Release: squeeze/sid
  APT prefers unstable
  APT policy: (500, 'unstable'), (500, 'stable'), (1, 'experimental')
Architecture: amd64 (x86_64)

Kernel: Linux 2.6.31-rc4 (PREEMPT)
Locale: LANG=en_US.UTF-8, LC_CTYPE=en_US.UTF-8 (charmap=UTF-8)
Shell: /bin/sh linked to /bin/bash

Versions of packages tftpd-hpa depends on:
ii  adduser                       3.110      add and remove users and groups
ii  debconf [debconf-2.0]         1.5.27     Debian configuration management sy
ii  libc6                         2.9-25     GNU C Library: Shared libraries
ii  libwrap0                      7.6.q-18   Wietse Venema's TCP wrappers libra

tftpd-hpa recommends no packages.

Versions of packages tftpd-hpa suggests:
pn  syslinux-common               <none>     (no description available)

-- debconf information excluded




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Syslinux Maintainers <syslinux@lists.debian-maintainers.org>:
Bug#544089; Package tftpd-hpa. (Sun, 30 Aug 2009 10:27:13 GMT) Full text and rfc822 format available.

Acknowledgement sent to daniel@debian.org:
Extra info received and forwarded to list. Copy sent to Debian Syslinux Maintainers <syslinux@lists.debian-maintainers.org>. (Sun, 30 Aug 2009 10:27:13 GMT) Full text and rfc822 format available.

Message #10 received at 544089@bugs.debian.org (full text, mbox):

From: Daniel Baumann <daniel@debian.org>
To: 544089-submitter@bugs.debian.org
Cc: 544089@bugs.debian.org
Subject: Re: tftpd-hpa: Does not start when Ipv6 is not available
Date: Sun, 30 Aug 2009 12:25:19 +0200
severity 544089 minor
tag 544089 upstream
thanks

Hi,

first of all, as you said, the bug is only appearing when using custom
kernels (therefore downgrading severity to minor).

second, a workaround for this is that you pass --ipv4 to the daemon
(debconf asks you for additional options, enter it there).

third, the bug in the actual code should be reported upstream. i'll do this.

Regards,
Daniel

-- 
Address:        Daniel Baumann, Burgunderstrasse 3, CH-4562 Biberist
Email:          daniel.baumann@panthera-systems.net
Internet:       http://people.panthera-systems.net/~daniel-baumann/




Severity set to 'minor' from 'normal' Request was from Daniel Baumann <daniel@debian.org> to control@bugs.debian.org. (Sun, 30 Aug 2009 10:27:14 GMT) Full text and rfc822 format available.

Added tag(s) upstream. Request was from Daniel Baumann <daniel@debian.org> to control@bugs.debian.org. (Sun, 30 Aug 2009 10:27:15 GMT) Full text and rfc822 format available.

Message sent on to Matthijs Kooijman <matthijs@stdin.nl>:
Bug#544089. (Sun, 30 Aug 2009 10:27:24 GMT) Full text and rfc822 format available.

Added tag(s) ipv6. Request was from Simon Paillard <simon.paillard@resel.enst-bretagne.fr> to control@bugs.debian.org. (Sat, 16 Jan 2010 19:48:17 GMT) Full text and rfc822 format available.

Severity set to 'serious' from 'minor' Request was from Clint Adams <schizo@debian.org> to control@bugs.debian.org. (Tue, 23 Mar 2010 01:03:40 GMT) Full text and rfc822 format available.

Severity set to 'minor' from 'serious' Request was from Daniel Baumann <daniel@debian.org> to control@bugs.debian.org. (Tue, 23 Mar 2010 05:30:02 GMT) Full text and rfc822 format available.

Set Bug forwarded-to-address to 'syslinux@zytor.com'. Request was from Daniel Baumann <daniel@debian.org> to control@bugs.debian.org. (Sat, 17 Jul 2010 23:39:03 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, goswin-v-b@web.de, Debian Syslinux Maintainers <syslinux@lists.debian-maintainers.org>:
Bug#544089; Package tftpd-hpa. (Fri, 05 Nov 2010 11:33:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Goswin von Brederlow <goswin-v-b@web.de>:
Extra info received and forwarded to list. Copy sent to goswin-v-b@web.de, Debian Syslinux Maintainers <syslinux@lists.debian-maintainers.org>. (Fri, 05 Nov 2010 11:33:03 GMT) Full text and rfc822 format available.

Message #30 received at 544089@bugs.debian.org (full text, mbox):

From: Goswin von Brederlow <goswin-v-b@web.de>
To: Debian Bug Tracking System <544089@bugs.debian.org>
Subject: Re: Does not start when Ipv6 is not available
Date: Fri, 05 Nov 2010 12:31:34 +0100
Package: tftpd-hpa
Version: 5.0-16
Severity: normal

I just got hit by the same bug:

Selecting previously deselected package tftpd-hpa.
(Reading database ... 160286 files and directories currently installed.)
Unpacking tftpd-hpa (from .../tftpd-hpa_5.0-16_amd64.deb) ...
Processing triggers for man-db ...
Setting up tftpd-hpa (5.0-16) ...
Starting HPA's tftpd: in.tftpdinvoke-rc.d: initscript tftpd-hpa, action "start" failed.
dpkg: error processing tftpd-hpa (--configure):
 subprocess installed post-installation script returned error exit status 71
Errors were encountered while processing:
 tftpd-hpa
E: Sub-process /usr/lib/apt-ma-emu/dpkg returned an error code (1)


This is seriously anoying behaviour. The package must not fail to
install without IPv6. You should at least check in postinst if IPv6
support is available and give a meaningfull error message. You could
also add -4 if IPv6 support is missing.

MfG
	Goswin

-- System Information:
Debian Release: squeeze/sid
  APT prefers unstable
  APT policy: (500, 'unstable')
Architecture: amd64 (x86_64)

Kernel: Linux 2.6.32-book-1 (SMP w/1 CPU core; PREEMPT)
Locale: LANG=C, LC_CTYPE=C (charmap=ANSI_X3.4-1968)
Shell: /bin/sh linked to /bin/bash

Versions of packages tftpd-hpa depends on:
ii  adduser                       3.112      add and remove users and groups
ii  debconf [debconf-2.0]         1.5.28     Debian configuration management sy
ii  libc6                         2.11.1-3   Embedded GNU C Library: Shared lib
ii  libwrap0                      7.6.q-18   Wietse Venema's TCP wrappers libra

tftpd-hpa recommends no packages.

Versions of packages tftpd-hpa suggests:
ii  syslinux-common            2:3.83+dfsg-3 Kernel loader which uses a FAT, ex

-- debconf information excluded




Changed Bug title to 'does not start without ipv6 kernel support' from 'tftpd-hpa: Does not start when Ipv6 is not available' Request was from Daniel Baumann <daniel.baumann@progress-technologies.net> to control@bugs.debian.org. (Sat, 12 Feb 2011 03:48:03 GMT) Full text and rfc822 format available.

Reply sent to Daniel Baumann <daniel.baumann@progress-technologies.net>:
You have taken responsibility. (Thu, 19 Jul 2012 16:21:04 GMT) Full text and rfc822 format available.

Notification sent to Matthijs Kooijman <matthijs@stdin.nl>:
Bug acknowledged by developer. (Thu, 19 Jul 2012 16:21:04 GMT) Full text and rfc822 format available.

Message #37 received at 544089-close@bugs.debian.org (full text, mbox):

From: Daniel Baumann <daniel.baumann@progress-technologies.net>
To: 544089-close@bugs.debian.org
Subject: Bug#544089: fixed in tftp-hpa 5.2-4
Date: Thu, 19 Jul 2012 16:17:44 +0000
Source: tftp-hpa
Source-Version: 5.2-4

We believe that the bug you reported is fixed in the latest version of
tftp-hpa, which is due to be installed in the Debian FTP archive.

A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 544089@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Daniel Baumann <daniel.baumann@progress-technologies.net> (supplier of updated tftp-hpa package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

Format: 1.8
Date: Thu, 19 Jul 2012 16:33:37 +0200
Source: tftp-hpa
Binary: tftp-hpa tftpd-hpa
Architecture: source i386
Version: 5.2-4
Distribution: unstable
Urgency: low
Maintainer: Daniel Baumann <daniel.baumann@progress-technologies.net>
Changed-By: Daniel Baumann <daniel.baumann@progress-technologies.net>
Description: 
 tftp-hpa   - HPA's tftp client
 tftpd-hpa  - HPA's tftp server
Closes: 544089
Changes: 
 tftp-hpa (5.2-4) unstable; urgency=low
 .
   * Adding note to readme about ipv6 kernel support (Closes: #544089).
Checksums-Sha1: 
 5da4c0ee5e81df0e239b4025fcf26e97118a36d1 1206 tftp-hpa_5.2-4.dsc
 434954f644f7660eae4779f3207a3398c2991dc1 21652 tftp-hpa_5.2-4.debian.tar.xz
 97272bba94f1c0b2d42a757a3737331b754ff59e 26732 tftp-hpa_5.2-4_i386.deb
 429d3640f524fa2fa1fbfee771044cac4e6272d8 47090 tftpd-hpa_5.2-4_i386.deb
Checksums-Sha256: 
 e28f3a6345496d0b9d8f4985e1f4290a760ab46419e4eccd621adfb16f4245f2 1206 tftp-hpa_5.2-4.dsc
 a3cb5eb07e89d3db8ebdf47690908e3e1ba6a91277619087ac70476bb8195a48 21652 tftp-hpa_5.2-4.debian.tar.xz
 7569cfc21684276624d9a94a1d0aef6fa2f37f8aaa1b5d60c81cfae49b717289 26732 tftp-hpa_5.2-4_i386.deb
 1f9ea26c47a311e686eb330e081e9ad4bf1fa026daf2b629e1adfd156258f880 47090 tftpd-hpa_5.2-4_i386.deb
Files: 
 54c4fac48f397cb42e9daaee4d4129e9 1206 net extra tftp-hpa_5.2-4.dsc
 a40ae996d9f9e5d636f3bc3328b126bd 21652 net extra tftp-hpa_5.2-4.debian.tar.xz
 45742dfb53472ee5c3eecdf684c424ae 26732 net extra tftp-hpa_5.2-4_i386.deb
 a4409a07230b54113c8459aa71347aad 47090 net extra tftpd-hpa_5.2-4_i386.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.10 (GNU/Linux)

iEYEARECAAYFAlAIMQEACgkQ+C5cwEsrK57GEQCdHoZar84QLuPBWFOAosjVASYk
sggAn1PYkL23ahMBhEWa6uNu5mwz7il3
=8k+J
-----END PGP SIGNATURE-----




Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Tue, 28 Aug 2012 07:29:37 GMT) Full text and rfc822 format available.

Bug unarchived. Request was from Don Armstrong <don@debian.org> to control@bugs.debian.org. (Wed, 14 Nov 2012 00:33:03 GMT) Full text and rfc822 format available.

Marked as found in versions tftp-hpa/5.0-18. Request was from Don Armstrong <don@debian.org> to control@bugs.debian.org. (Wed, 14 Nov 2012 00:33:04 GMT) Full text and rfc822 format available.

Merged 544089 690535 Request was from Don Armstrong <don@debian.org> to control@bugs.debian.org. (Wed, 14 Nov 2012 00:33:07 GMT) Full text and rfc822 format available.

Added tag(s) squeeze. Request was from Don Armstrong <don@debian.org> to control@bugs.debian.org. (Wed, 14 Nov 2012 00:33:08 GMT) Full text and rfc822 format available.

Removed tag(s) squeeze. Request was from Andreas Beckmann <anbe@debian.org> to control@bugs.debian.org. (Sat, 18 Jan 2014 13:45:33 GMT) Full text and rfc822 format available.

Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Sun, 16 Feb 2014 07:35:25 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Thu Apr 17 22:00:51 2014; Machine Name: buxtehude.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.